<?php
/**
 * Created by PhpStorm.
 * User: roc
 * Date: 2019/9/10
 * Time: 20:02
 */

namespace kwy\kwy_third_merchant_sdk\Common;


class Util
{
    ###  文件下载 ###
    /**
     * 下载文件
     * @param $url
     * @param string $fileSuffix
     * @param string $path
     * @return string
     */
    public static function downloadFile($url,$fileSuffix='',$path=''){
        //文件后缀名
        $arr = explode('.', $url);
        $type=end($arr);
        if(empty($fileSuffix)){
            $type = strtolower($type);
        }else{
            $type = $fileSuffix;
        }
        $file_name=date("YmdHis").mt_rand(1000, 9999).'.'.$type;
        //创建下载目录
        if (!file_exists($path)) {
            mkdir($path, 0777, true);
        }
        $file_path = $path.'/'.$file_name;
        $img = file_get_contents($url);
        file_put_contents($file_path,$img);
        return $file_path;
    }

    /**
     * 下载证件信息
     * @param $url
     * @param $file_name
     * @param $path
     * @param int $maxSize  图片最大大小
     * @return string
     * @throws \Exception
     */
    public function downloadPic($url,$file_name='',$path='',$maxSize=1024000){
        //文件后缀名
        $arr = explode('.', $url);
        $type=end($arr);
        $type = strtolower($type);

        if(empty($file_name)){
            $file_name=date("YmdHis").mt_rand(1000, 9999).'.'.$type;
        }else{
            $file_name .= '.'.$type;
        }
        //创建下载目录
        if (!file_exists($path)) {
            mkdir($path, 0777, true);
        }
        $file_path = $path.'/'.$file_name;

        $url = $this->getCompressPicUrl($url,$maxSize);  //获取压缩后图片的地址
        $img = file_get_contents($url);
        file_put_contents($file_path,$img);
        return $file_path;
    }

    /**
     * 获取压缩后的图片地址（阿里oss的图片资源才支持）
     * @param $pic_url
     * @param int $maxSize
     * @return string
     * @throws \Exception
     */
    private function getCompressPicUrl($pic_url,$maxSize=1024000){
        for($i = 100 ; $i>=10; $i=$i-10){
            $tmp_pic_url = $pic_url.'?x-oss-process=image/resize,p_'.$i;
            $size = self::getRemoteFileSize($tmp_pic_url);
            //如果返回false，直接压缩一半
            if($size === false){
                $i = $i-40;
                continue;
            }
            if($size < $maxSize){
                return $tmp_pic_url;
            }
        }
    }

    /**
     * 获取远程文件的大小
     * @param $url
     * @param string $user
     * @param string $pw
     * @return mixed
     * @throws \Exception
     */
    public static function getRemoteFileSize($url, $user = "", $pw = "")
    {
        ob_start();
        $ch = curl_init($url);
        curl_setopt($ch, CURLOPT_HEADER, 1);
        curl_setopt($ch, CURLOPT_NOBODY, 1);

        $headers = [
            'cache-control' => 'no-cache',
            'content-type' => 'multipart/form-data; boundary=----WebKitFormBoundary7MA4YWxkTrZu0gW',
            'postman-token' => '908c8726-92e5-aab2-10b2-d2c58d10b414'
        ];
        if(!empty($user) && !empty($pw))
        {
            $headers[] = array('Authorization: Basic ' .  base64_encode("$user:$pw"));
            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        }
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');

        $info = curl_exec($ch); //文件
        curl_close($ch);
        $head = ob_get_contents();
        ob_end_clean();

        //获取返回类型
        $regex = '/Content-Type:\s([a-zA-Z\/].+?)\s/';
        preg_match($regex, $head, $typeMatches);
        if(isset($typeMatches[1]) && $typeMatches[1] == 'application/xml'){
            return false;
        }

        //获取图片大小
        $regex = '/Content-Length:\s([0-9].+?)\s/';
        preg_match($regex, $head, $matches);
        if(!isset($matches[1])){
            throw new \Exception('获取图片大小失败');
        }
        return $matches[1];
    }

    /**
     * 本地获取压缩图片
     * @param $file_path    文件路径
     * @param int $need_size    压缩后的图片大小,单位kb
     * @return bool|string
     * @throws \Exception
     */
    public static function get_thumb_img($file_path,$need_size=1024){
        $dir=dirname($file_path);
        if(!file_exists($file_path)) return false;

        $size = filesize($file_path)/1000;//kb

        $img_info=getimagesize($file_path);
        $width = $img_info[0];
        $height = $img_info[1];
        $ext='';
        if ($img_info['mime']=="image/jpeg"){
            $source_image = imagecreatefromjpeg($file_path);
            $ext='jpg';
        }elseif ($img_info['mime']=="image/png"){
            $source_image = imagecreatefrompng($file_path);
            $ext='png';
        }elseif ($img_info['mime']=='image/gif'){
            $source_image = imagecreatefromgif($file_path);
            $ext='gif';
        }


        if ($size>$need_size){
            /*$times = round($size/$need_size,2);
            $times = sqrt($times);
            $new_width = floor($width/$times);
            $new_height = floor($height/$times);
            echo $new_height.'<hr>';
            echo $new_width;*/
            $tmp = 3000;
//            echo $width.'<hr>';
//            echo $height.'<hr>';
            if($width > $height){
                $new_width = $tmp;
                $time = $height/$width;
                $new_height = $height * $time;
            }else{
                $new_height = $tmp;
                $time = $width/$height;
                $new_width = floor($width * $time);
            }
            $tar_img=imagecreatetruecolor($new_width,$new_height);
            imagecopyresampled($tar_img, $source_image,0,0,0,0, $new_width, $new_height, $width, $height);
            imagedestroy($source_image);
            $source_image=$tar_img;

            $new_path=$dir.'/thumb_'.date('YmdHis').mt_rand(1000,9999).'.'.$ext;
            if(!is_writable($dir)){
                throw new \Exception($dir.'文件不可写');
            }
            $ret=imagejpeg($source_image,$new_path,50);
            //header('Content-Type: image/jpeg');
            //$ret=imagejpeg($source_image);
            if ($ret==false) return false;
            imagedestroy($source_image);

            return $new_path;
        }
        return $file_path;
    }

    ###  文件下载  ###

    /**
     * 输出xml字符
     * @param $values
     * @return string
     * @throws \Exception
     */
    public function ToXml($values)
    {
        if(!is_array($values)
            || count($values) <= 0)
        {
            throw new \Exception("数组数据异常！");
        }

        $xml = "<xml>";
        foreach ($values as $key=>$val)
        {
            if (is_numeric($val)){
                $xml.="<".$key.">".$val."</".$key.">";
            }else{
                $xml.="<".$key."><![CDATA[".$val."]]></".$key.">";
            }
        }
        $xml.="</xml>";
        return $xml;
    }

    /**
     * 获取随机字符串
     * @param int $len  随机数长度
     * @return string
     */
    public static function getNonceStr($len = 32)
    {
        $chars = "abcdefghijklmnopqrstuvwxyz0123456789";
        $str = "";
        for ($i = 0; $i < $len; $i++) {
            $str .= substr($chars, mt_rand(0, strlen($chars) - 1), 1);
        }
        return $str;
    }
}